// SHOCK BLACKJACK (CARD GAME)
// By doti, Banjo, ptdw
// Banjo: banjosbbs@hotmail.com
// Banjo: www.banjosbbs.blogspot.com
// Version 1.1
//
// CREDITS:
// Original script by Doti, published as 'The White Queen'.
// 'Spank Blackjack' variation script additions and changes by Banjo.
// 'Shock Blackjack' variation script additions and changes by ptdw
// Standard card deck images by John Fitzgibbon (http://www.jfitz.com/cards/)
// Opponent images sourced from various free web preview galleries.
// Card sounds from www.freesound.org, edited by Banjo from sounds originally recorded by F4ngy.
//
// COPYRIGHT:
// This script, from http://ss.deviatenow.com, is protected by this licence:
// CC BY-NC-ND, see http://creativecommons.org/licenses/by-nc-nd/4.0/
// This copyright refers only to this script itself; it does not include any other included resources (images, music, sounds, etc.) which remain the property of their owners.
//
// SCRIPT RESOURCES
// This contains a list of files included with the script when published to the SexScripts website
//

//Metadata
setInfos(4, "Shock Blackjack",
	"A Blackjack card game with shocking penalties",
	"Banjo, Doti, ptdw",
	"v1.1", 0xFFFFFF,"en",
	["game", "estim", "strip","femaledom", "formale"]);

//Player setup
def path = "shockblackjack"
def player = loadString("intro.name")
def manlady = "man"
def boygirl = "boy"
def bratbitch = "brat"
def cockpussy = "cock"
def depants = "Pull your pants and underwear down"
if(loadBoolean("intro.female"))
{
	manlady = "lady"
	boygirl = "girl"
	bratbitch = "bitch"
	cockpussy = "pussy"
	depants = "Bare your bottom"
}

// Load Clothing
def playerClothing = [null]
playerClothing[0] = loadString("shockblackjack.cloth0")
playerClothing[1] = loadString("shockblackjack.cloth1")
playerClothing[2] = loadString("shockblackjack.cloth2")
playerClothing[3] = loadString("shockblackjack.cloth3")
playerClothing[4] = loadString("shockblackjack.cloth4")
playerClothing[5] = loadString("shockblackjack.cloth5")

def playerLivesStart = 6 //Number of times the player can lose before game over; corresponds to how many "layers" of clothing the player is wearing

if (playerClothing[0] == null) {
	playerClothing[0] = "shoes"
	playerClothing[1] = "socks"
	playerClothing[2] = "shirt"
	playerClothing[3] = "undershirt"
	playerClothing[4] = "pants"
	playerClothing[5] = "underpants"
	if(loadBoolean("intro.female")) {
		playerClothing[0] = "shoes"
		playerClothing[1] = "socks"
		playerClothing[2] = "top"
		playerClothing[3] = "skirt or pants"
		playerClothing[4] = "bra"
		playerClothing[5] = "panties"
	}
}

//Game setup
def tripledBefore = false
def gamename = "Shock Blackjack"
def menu = 0
def quit = false
def greeting = "Ready to play?"
def gameModeDebug = false //Edit this manually to true to enable debugging mode
def gameModeRegen = true //Whether winning a hand lets the player or opponent put a removed piece of clothing back on (true) or not (false)
def gameModeStrip = true //Player and opponent strip when they lose a hand (true) or remain clothed (false)
def points = "penalty points" //Text name for the points being bet, won and lost
def bet = 10 //How many points/spanks the player earns or reduces their total by per hand
def deck = 0 //Which card deck (card back images) to display; read from the subfolders in the 'cards' image folder
if(loadBoolean("shockblackjack.custom")) {
	gameModeStrip = loadBoolean("shockblackjack.gameModeStrip")
	gameModeRegen = loadBoolean("shockblackjack.gameModeRegen")
	bet = loadInteger("shockblackjack.bet")
	deck = loadString("shockblackjack.deck")
	playerLivesStart = loadInteger("shockblackjack.lives")
}
def moved = false
if (playerLivesStart == null) playerLivesStart = 6

//Default implements
def baseImplementSound = "estim3"

//Default opponent
def opponent = "White Queen"
def respectTitle = "Miss"
def opponent_pics = 2
def opponent_pics2 = 2
def opponentLivesStart = 6 //Number of times this opponent can lose before game over; corresponds to how many "layers" of clothing the opponenent is wearing
def meet1 = "Hi, I'm The "+opponent+"."
def meet2 = "\n\nWhat's your name?"
def meet3 = "It's nice to meet you, "+player+"."
def meet4 = "Let's play '"+gamename+"'."
def intro1 = "Hi! I'm Alexis!\n\nYou wanna see me naked? Let's play strip blackjack!\n\nBut if you lose, I get to torture you!"
def backagain1 = "Want to play '"+gamename+"' with me again?"
def backagain2 = "Back for another game of '"+gamename+"'?"
def refuse1 = "Aww, too bad!\n\nMaybe some other time?"
def goodbye1 = "Now wasn't that a fun game?\n\nCome back soon so we can play again."

//Opponents
def opponent1 = "Alexis"

def opponentSet1 = {
	opponent = "alexis"
	respectTitle = "Miss"
	opponent_pics = 2
	opponent_pics2 = 2
	opponentLivesStart = 6
	meet1 = "Hi, I'm "+opponent+"."
	meet2 = meet2
	meet3 = meet3
	meet4 = meet4
	intro1 = intro1
	backagain1 = backagain1
	backagain2 = backagain2
	refuse1 = refuse1
	goodbye1 = goodbye1
}

def setImageSpank = {
	setImage("shockblackjack/shock.png")
}

//Config menu
def setCustom = {
	bet = getInteger("Enter the "+points+" you want to bet per hand.\n\n(default is 10, current is "+bet+")",bet)
	while(bet<1) {
		bet = getInteger("You must set the bet to at least 1.\n\n(default is 10)",bet)
	}
	gameModeStrip = getBoolean("Should players strip when they lose a round?\n\n(default is true, current is "+gameModeStrip+")","True","False")
	if(gameModeStrip) gameModeRegen = getBoolean("Should players put clothes back on when they win a round?\n\n(default is true, current is "+gameModeRegen+")","True","False")
	else gameModeRegen = getBoolean("Should players negate a previous loss when they win a round?\n\n(default is true, current is "+gameModeRegen+")","True","False")
	playerLivesStart = 0
	while ((playerLivesStart < 2) ||  (playerLivesStart > 6)) {
    		playerLivesStart = getInteger("Before we start, how many articles of clothing are you wearing, "+player+"? [2-6]",6)
	}

    if(getBoolean("Would you like to customize thier names?","Yes","No")) {
        for (def l=1;l<=playerLivesStart;l++) {
            playerClothing[l-1] = getString("Tell me what you are wearing for article number "+l+". "
            +"\n\nArticles will be removed in order, from lowest to highest.", playerClothing[l-1])
            switch(l) {
            case 1:
                save("shockblackjack.cloth0",playerClothing[l-1])
                break
            case 2:
                save("shockblackjack.cloth1",playerClothing[l-1])
                break
            case 3:
                save("shockblackjack.cloth2",playerClothing[l-1])
                break
            case 4:
                save("shockblackjack.cloth3",playerClothing[l-1])
                break
            case 5:
                save("shockblackjack.cloth4",playerClothing[l-1])
                break
            case 6:
                save("shockblackjack.cloth5",playerClothing[l-1])
                break
            }
        }
    }

	save("shockblackjack.bet",bet)
	save("shockblackjack.lives",playerLivesStart)
	save("shockblackjack.gameModeStrip",gameModeStrip)
	save("shockblackjack.gameModeRegen",gameModeRegen)
	save("shockblackjack.deck",deck)
	save("shockblackjack.custom",true)
	show("Settings changed.")
	wait(5)
}

def resetGame = {
	bet = 10
	deck = 0
	gameModeStrip = true
	gameModeRegen = true
	save("shockblackjack.implements_set",false)
	save("shockblackjack.bet",bet)
	save("shockblackjack.gameModeRegen",gameModeRegen)
	save("shockblackjack.gameModeStrip",gameModeStrip)
	save("shockblackjack.deck",deck)
	save("shockblackjack.custom",true)
	save("shockblackjack.lives",6)
	save("shockblackjack.inpunish",false)
	show("Settings reset to defaults.\n\nGame will quit after exiting config.")
	wait(5)
	quit = true
}

def resetTotal = {
	bet = 10
	deck = 0
	gameModeStrip = true
	gameModeRegen = true
	save("shockblackjack.implements_set",false)
	save("shockblackjack.bet",bet)
	save("shockblackjack.gameModeRegen",gameModeRegen)
	save("shockblackjack.gameModeStrip",gameModeStrip)
	save("shockblackjack.deck",deck)
	save("shockblackjack.custom",true)
	show("Settings reset to defaults.")
	wait(5)
	quit = true
}

def changeSettings = {
	def loopmenu = true
	while(loopmenu) {
		menu = getSelectedValue("What do you want to do?", ["Exit Config", "Customize", "Reset Game", "Total Reset"])
		if(menu==0) loopmenu = false
		else if(menu==1) setCustom()
		else if(menu==2) resetGame()
		else if(menu==3) resetTotal()
	}
}

//Basic variables and definitions
def playerLivesCurrent = playerLivesStart
def opponentLivesCurrent = opponentLivesStart
def strip_level = 0

def totalPoints = 0
def roundPoints = 0
def win = 0
def loss = 0
def totalWins = 0
def totalLosses = 0

def opponentLosses = 0
def playerLosses = 0

def getRandomItem = { itemKeys ->
	for ( key in itemKeys ) {
		if ( !loadBoolean(key) ) itemKeys -= key
	}
	if ( itemKeys.isEmpty() ) return null
	return itemKeys[ getRandom(itemKeys.size()) ]
}

def spankSound = baseImplementSound
def spankSoundLimit = 3

def spank = {
	message, spanks, time ->
	show(""+message+"\n\n. . ")
	def x = 0
	(1..spanks).each {
		x++
		show(message+"\n\n."+x+".")
		playBackgroundSound("shockblackjack/"+spankSound+".wav")
		wait(time)
	}
}

def turns = 0
def waiting = 2 + (2 / (1+turns/4))

def doneCards = []

def getCard = { 
	def ok = false
	def card = null
	while(!ok) {
		card = getRandom(52)
		ok = !doneCards.contains(card)
	}
	doneCards.add(card)
	if(doneCards.size==52)
		doneCards.clear()
	return card
}

def getScore = { card -> 
	if(card<4)
		return 11
	if(card<40)
		return (int)Math.ceil((card+1)/4)
	return 10
}

def getFullScore = { cards ->
	def res = 0
	for(def c : cards)
		res += getScore(c)
	if(res>21) {
		for(def c : cards)
			if(getScore(c)==11 && res>21)
				res-=10
	}
	return (int)res
}

def getCardName = { card ->
	def values = ["Ace","2","3","4","5","6","7","8","9","10","Jack","Queen","King"]
	def colors = ["Clubs", "Diamonds", "Hearts", "Spades"]
	return values[(int)Math.floor(card/4)]+" of "+colors[card%4]
}

//Display card images
def showCards= { cards -> 
	def width = 540
	def height = 500
	def image = new java.awt.image.BufferedImage(width, height, java.awt.image.BufferedImage.TYPE_4BYTE_ABGR)
	def graphics = image.getGraphics()
	def sampleImage = java.awt.Toolkit.getDefaultToolkit().getImage(
		"images/cards/deck"+deck+"/0.png")
	def oneWidth = sampleImage.getWidth()
	def oneHeight = sampleImage.getHeight()
	for(def i = 0;i<cards.size;i++)
		for(def j = 0;j<cards[i].size;j++) {
			def x = j * (width - oneWidth) / (Math.max(2,cards[i].size-1))
			def delta = (i*j + i * 5 + j * 7) % 4
			def y = i * (height - oneHeight - 3) / (Math.max(1,cards.size-1)) + delta
			def thisImage = javax.imageio.ImageIO.read(new File("images/cards/deck"+deck+"/"+cards[i][j]+".png"))
			if(i==0) {
				graphics.rotate(Math.PI, width/2, (oneHeight + 3)/2)
			}
			graphics.drawImage(thisImage, (int)x, (int)y, null)
			if(i==0) {
				graphics.rotate(-Math.PI, width/2, (oneHeight + 3)/2)
			}
		}
	setImage(image, false)
}

//Randomly select an image
def setImageGame = {
	def imageNumber = getRandom(opponent_pics)+1
	setImage("shockblackjack/"+opponent+"_playing"+imageNumber+".jpg")
}


def setImageStrip = {
	def imageNumber = strip_level
	setImage("shockblackjack/"+opponent+"_strip"+imageNumber+".jpg")
}

def setImageStripPlayer = {
    def imageNumber = strip_level
    setImage(path+"/strip"+imageNumber+".jpg")
}

//Show main opponent images
def setImageMain = {
	setImage("shockblackjack/"+opponent+"_intro.jpg")
}

def setImageWon = {
	setImage("shockblackjack/"+opponent+"_won.jpg")
}

def setImageLost = {
	setImage("shockblackjack/"+opponent+"_lost.jpg")
}

//Set correct player image
def setPlayerImage = {
	def randPic = getRandom(2)
	if (path != "me") randPic = 1

    if(playerLivesStart-playerLivesCurrent==playerLivesStart-1 && randPic==0) {
        strip_level = "5b"
        setImageStripPlayer()
    }
    if(playerLivesStart-playerLivesCurrent==playerLivesStart-1) {
        strip_level = "5a"
        setImageStripPlayer()
    }
    else if(playerLivesStart-playerLivesCurrent==playerLivesStart-2 && randPic==0) {
        strip_level = "4b"
        setImageStripPlayer()
    }
    else if(playerLivesStart-playerLivesCurrent==playerLivesStart-2) {
        strip_level = "4a"
        setImageStripPlayer()
    }
    else if(playerLivesStart-playerLivesCurrent==playerLivesStart-3 && randPic==0) {
        strip_level = "3b"
        setImageStripPlayer()
    }
    else if(playerLivesStart-playerLivesCurrent==playerLivesStart-3) {
        strip_level = "3a"
        setImageStripPlayer()
    }
    else if(playerLivesStart-playerLivesCurrent==playerLivesStart-4 && randPic==0) {
        strip_level = "2b"
        setImageStripPlayer()
    }
    else if(playerLivesStart-playerLivesCurrent==playerLivesStart-4) {
        strip_level = "2a"
        setImageStripPlayer()
    }
    else if(playerLivesStart-playerLivesCurrent==playerLivesStart-5 && randPic==0) {
        strip_level = "1b"
        setImageStripPlayer()
    }
        else if(playerLivesStart-playerLivesCurrent==playerLivesStart-5) {
        strip_level = "1a"
        setImageStripPlayer()
    }
    else {
        if (randPic==0)
            strip_level = "6b"
        else
            strip_level = "6a"

        setImageStripPlayer()
    }
}

//Set correct opponent image
def setOpponentImage = {
    if(opponentLivesStart-opponentLivesCurrent==opponentLivesStart) {
        setImageWon()
    }
    else if(opponentLivesStart-opponentLivesCurrent==opponentLivesStart-1 && getRandom(2)==0) {
		strip_level = "4a"
		setImageStrip()
	}
    else if(opponentLivesStart-opponentLivesCurrent==opponentLivesStart-1) {
        strip_level = "4b"
        setImageStrip()
    }
    else if(opponentLivesStart-opponentLivesCurrent==opponentLivesStart-2 && getRandom(2)==0) {
		strip_level = "3b"
		setImageStrip()
	}
	else if(opponentLivesStart-opponentLivesCurrent==opponentLivesStart-2) {
		strip_level = "3a"
		setImageStrip()
	}
	else if(opponentLivesStart-opponentLivesCurrent==opponentLivesStart-3) {
		strip_level = "2b"
		setImageStrip()
	}
	else if(opponentLivesStart-opponentLivesCurrent==opponentLivesStart-4 && getRandom(2)==0) {
		strip_level = "1b"
		setImageStrip()
	}
	else if(opponentLivesStart-opponentLivesCurrent==opponentLivesStart-4) {
		strip_level = "1a"
		setImageStrip()
	}
	else if(opponentLivesStart-opponentLivesCurrent==opponentLivesStart-5 && getRandom(2)==0) {
		strip_level = "0b"
		setImageStrip()
	}
	else if(opponentLivesStart-opponentLivesCurrent==opponentLivesStart-5) {
		strip_level = "0a"
		setImageStrip()
	}
	else {
		setImageGame()
	}
}

//Opponent wins the game
def opponentWonGame = {
	save("shockblackjack.inpunish",true)
	save("shockblackjack.points",totalPoints)
	show("Game over! You lost!")
	wait(5)
	setImageSpank()
	if(gameModeStrip) {
		show("You have been stripped completely naked and now you have a shocking coming to you!"
			+"\n\nBy my count, you've earned "+totalPoints+" shocks, young "+manlady+".")
	}
	else {
		def spankingClothesMessageArray = [""+depants+", "+player+". You have a shocking coming to you!",
			"Take your clothes off, "+player+". This is going to be a naked shocking!",
			"Take off everything except your socks and underwear, "+player+", then pull your underpants down to your knees."]
		def spankingClothesState = getRandom(3)
		show(""+spankingClothesMessageArray[spankingClothesState]+""
			+"\n\nBy my count, you've got "+totalPoints+" shocks coming to you, young "+manlady+".")
	}
	showButton("Ready, "+respectTitle+".")
	setImageSpank()

    // Figure out what body part to punish
	setOpponentImage() 
    def bodyPart = "ass cheeks"
    def resultText = "I'm going to go easy on you"
	def z = 6*(opponentLivesCurrent/opponentLivesStart)
    def itemsRemoved = 6-z.toInteger()-getRandom(2)
	def electrode = ""
    if (itemsRemoved <= 0) {
        bodyPart = "penis head"
      	electrode = "shockblackjack/penis head.jpg"
        resultText = "I'm going to inflict the maximum amount of pain"
    }
    else if (itemsRemoved == 1) {
        bodyPart = "ass hole"
      	electrode = "shockblackjack/ass hole.jpg"
        resultText = "I'm going to give you quite a lot of pain"
    }
    else if (itemsRemoved == 2) {
        bodyPart = "penis shaft"
      	electrode = "shockblackjack/penis shaft.jpg"
        resultText = "I'm going to be a mean"
    }
    else if (itemsRemoved == 3) {
        bodyPart = "balls"
      	electrode = "shockblackjack/balls.jpg"
        resultText = "I'm going to be a little mean"
    }
    else if (itemsRemoved == 4) {
      	electrode = "shockblackjack/ass cheeks.jpg"
        bodyPart = "thighs"
        resultText = "I'm going to be nice"
    }

    if (itemsRemoved == 5)
        show("Since I'm barely dressed, "+resultText+" and shock your "+bodyPart+".")
    else
        show("Since I'm still wearing "+opponentLivesCurrent+" articles, "+resultText+" and shock your "+bodyPart+".")

    spankSound = baseImplementSound
    showButton("I can accept that, "+respectTitle+".")

	show("Alright, then, "+player+"...\n\nAttach the electrodes to your "+bodyPart+".")
	setImage(electrode)
	showButton("I'm ready, "+respectTitle+".")
	setImageMain()
    show("To be honest, this is going to be quite painful. It\'s less punishemnt, and more torture. "
        +"I need to ensure that you don\'t chicken out and leave early...")
    	showButton("*gulp*")
	show("You must be tied up tightly enough that you cannot quickly escape, even if you change your mind."
        +"\n\nGet the supplies you need to tie yourself up. After you've collected your things, I\'ll give you "
        +"three minutes to tightly bind yourself. After that, I will automatically start the torture.")
	showButton("I've collected the things I need")
	show("You may also want to get something to bite on to help with the pain. Again, this will really, really hurt! "
        +"\n\nYou knew this was a possibility when you agreed to play the game with me, so to be frank you have no choice in the matter. "
        +"\n\nShut up and suffer like a man! ")
    showButton("I'm ready to be punished!")

	show("Tie yourself up and wait for me to begin!")
	setImageSpank()

    wait(180)
	spank("Here we go, young "+manlady+"! This is going to be brutal!",totalPoints,3)
	setImageLost()
	show("Aww! Did that hurt, poor "+boygirl+"?\n\nWell, that's the price you pay for losing!")
	wait(10)
	save("shockblackjack.inpunish",false)
}

//Game Intro
def intro = {
	greeting = meet4
	greeting = intro1
	def mainmenu = true
	while(mainmenu) {
		menu = getSelectedValue(greeting, ["Ok", "No", "Config"])
		if(menu==0)
			mainmenu = false
		else if(menu==1) {
			show(refuse1)
			wait(5)
			mainmenu = false
			quit = true
		}
		else if(menu==2) changeSettings()
	}
}

//Rules explaination
def rulesDisplay = {
	if(!getBoolean("Do you know how to play regular Blackjack, "+player+"?")) {
		show("That doesn't say much for your chances, I'm afraid.\n\nAlright, the basic rules:\n\n"+
			"To win a hand, the combined value of your cards must be as close to 21 as possible, but no more.\n\n"+
			"A face card (Jack, Queen, King) is worth 10.\n\n"+
			"An Ace is worth 1 or 11.\n\n"+
			"If you have a face card and an Ace, that's Blackjack... it's an automatic win!")
		showButton("I understand, "+respectTitle+".")
	}
	if(gameModeStrip) {
		show("For this game, I'll be the dealer."
			+"\n\nIf I win a hand, you must remove one item of clothing and you will earn "+bet+" "+points+"."
			+"\n\nIf you win a hand, I will remove one item of clothing, and you get to reduce your total "+points+" by "+bet+"."
			+"\n\nIf you win, I will let you stroke yourself for me."
			+"\n\nIf you lose, you will receive shocks equal to your final "+points+" amount..."
            +"\n\nand I will choose where to shock you based on how close you came to stripping me."
            +"\n\nUnderstand?")
	}
	else {
		show("For this game, I'll be the dealer."
			+"\n\nIf I win a hand, you will earn "+bet+" "+points+"."
			+"\n\nIf you win a hand, you get to reduce your total "+points+" by "+bet+"."
			+"\n\nIf you win, I will let you stroke yourself for me."
			+"\n\nIf you lose, you will be shocked equal to your final "+points+" amount..."
            +"\n\nand I will choose where to shock you based on how close you came to stripping me."
            +"\n\nUnderstand?")
	}
	showButton("Yes, "+respectTitle+".")

    show("There's just one other little thing you should be aware of. If you bust, you will be shocked immeditaly! "
        +"The number of shocks will be equal to the difference between your hand and 21."
        +"\n\nYou will also be shocked immediately if you fold--the shocks you receive will equal the total value of the cards "
        +"that you're throwing away.  That will probably discourage you from folding in all but dire conditions!"
        +"\n\nThe electrodes will be attached to your ass cheeks for the majority of the game. However, once you are "
        +"down to your last article of clothing, I may choose to have you move the electrodes to a much more "
        +"sensitive area to provide extra motivation. *wink*")

    showButton("*gulp*")

	if(gameModeStrip) {
		if(gameModeRegen) show("Also, the winner of a hand who has already lost one or more items of clothing may put one item back on."
			+"\n\nRegardless of "+points+", the game is over when one of us is completely naked.")
		else show("Regardless of "+points+", the game is over when one of us is completely naked.")
	}
	else {
		if(gameModeRegen) show("Regardless of "+points+", the game is over when you have lost "+opponentLivesStart+" hands, or I have lost "+playerLivesStart+" hands."
			+"\n\nHowever, the winner of a hand gets to decrease their total losses by 1... meaning the game can go on a lot longer if we both keep winning and losing.")
		else show("Regardless of "+points+", the game is over when you have won "+opponentLivesStart+" hands, or I have won "+playerLivesStart+" hands.")
	}
	showButton("I see, "+respectTitle+".")
	show("We will play with 2 decks, with no insurance or splitting allowed.\n\n"+
		"Blackjack will 'pay' double the normal "+points+", for better or worse!\n\n"+
		"You may fold early to avoid losing a hand, although you'll still earn half the normal "+points+"!\n\n"+
		"You may double down to double your "+points+"... but keep in mind, that's win or lose!")
	showButton("Yes, "+respectTitle+".")
}

//Blackjack hand
def playBlackjackHand = {
	def cards = [[],[]]
    def tripled = false

    // 1 in 5 chance of triple points round
    if ((getRandom(5)==0) && !tripledBefore) {
        setImage("shockblackjack/3x.png")
        show("*** TRIPLE POINTS ROUND ***\n\n"+
        "Let's see how confident you are this time! The next round (for better or worse) is worth triple points!'\n\n"+
        "Be very, very careful this round. You will end up in a lot of pain if you lose this one!")
        showButton("I understand the risk")

		// If the electrode wasn't already moved, move it now
        if(playerLivesStart-playerLivesCurrent!=playerLivesStart-1) {
       		setImage("shockblackjack/ass hole.jpg")
			show("Of course, we're also going to need to move those electrodes to a more 'motivational' location!'\n\n"+
        		"Connect the insertable electrode, and put it in your ass for this round!")
       		showButton("*gulp*")
			moved = true
		}

        tripled = true
        tripledBefore = true
    } else if (moved) {
		show("You may now remove the insertable electrode, and put the others back on.")
       	showButton("OK")
		moved = false
	}

    cards[1].add(getCard())
	showCards(cards)
	show("Your first card: "+getCardName(cards[1][0])+".\n\n"+
		"My hand: "+getFullScore(cards[0])+"\n"+
		"Your hand: "+getFullScore(cards[1])+"")
	wait(waiting)
	cards[0].add(getCard())
	showCards(cards)
	show("My first card: "+getCardName(cards[0][0])+".\n\n"+
		"My hand: "+getFullScore(cards[0])+"\n"+
		"Your hand: "+getFullScore(cards[1])+"")
	wait(waiting)
	cards[1].add(getCard())
	showCards(cards)
	show("Your second card: "+getCardName(cards[1][1])+".\n\n"+
		"My hand: "+getFullScore(cards[0])+"\n"+
		"Your hand: "+getFullScore(cards[1])+"")
	wait(waiting)
	def doubled = false
    def passed = false
	def surrendered = false
	while(getFullScore(cards[1])<21 && !passed && !doubled && !surrendered) {
		def choice = -1
		if(cards[1].size==2)
			choice = getSelectedValue("What do you want to do?\n\n"+
				"My hand: "+getFullScore(cards[0])+"\n"+
				"Your hand: "+getFullScore(cards[1])+"", ["Hit", "Stand", "Double", "Fold"])
		else	
			choice = getSelectedValue("What do you want to do?\n\n"+
				"My hand: "+getFullScore(cards[0])+"\n"+
				"Your hand: "+getFullScore(cards[1])+"", ["Hit", "Stand"])
		passed = choice==1
		def startwords = ""
		if(choice==2) {
			doubled = true
			startwords = "You double down.\n\n"
		}
		if(choice==0 || choice==2) {
			cards[1].add(getCard())
			showCards(cards)
			show(startwords+"Your card: "+getCardName(cards[1][cards[1].size-1])+".\n\n"+
				"My hand: "+getFullScore(cards[0])+"\n"+
				"Your hand: "+getFullScore(cards[1])+"")
            if(getFullScore(cards[1])<=21)
                wait(waiting)
		}
		if(choice==3) {
			surrendered = true
		}
	}

    if(doubled)
		roundPoints = bet * 2
    if(!doubled)
		roundPoints = bet
    if(tripled)
        roundPoints = roundPoints * 3
        tripled = false
	if(surrendered) {
		roundPoints = roundPoints / 2
		totalPoints += roundPoints

        // Administer shocks
        spankSound = baseImplementSound
        spank("Administering shocks!",getFullScore(cards[1]),3)

        show("Folding already? Alright.\n\n"+
        "My hand: "+getFullScore(cards[0])+"\n"+
        "Your hand: "+getFullScore(cards[1])+"")
    }
	else if(getFullScore(cards[1])>21) {

        // Administer shocks
        spankSound = baseImplementSound
        spank("Administering shocks!",getFullScore(cards[1])-21,3)

		roundPoints = roundPoints
		totalPoints += roundPoints
		show("You bust! You lose this hand.\n\n"+
			"My hand: "+getFullScore(cards[0])+"\n"+
			"Your hand: "+getFullScore(cards[1])+"")
			loss = 1
			win = -1
	} else {
		cards[0].add(getCard())
		showCards(cards)
		show("My second card: "+getCardName(cards[0][1])+".\n\n"+
			"My hand: "+getFullScore(cards[0])+"\n"+
			"Your hand: "+getFullScore(cards[1])+"")
		wait(waiting)
		while(getFullScore(cards[0])<17 && getFullScore(cards[0])<=getFullScore(cards[1])) {
			cards[0].add(getCard())
			showCards(cards)
			show("My card: "+getCardName(cards[0][cards[0].size-1])+".\n\n"+
				"My hand: "+getFullScore(cards[0])+"\n"+
				"Your hand: "+getFullScore(cards[1])+"")
			wait(waiting * 0.8)
		}
		if(getFullScore(cards[0])>21) {
			totalPoints -= roundPoints
			show("I bust! You win this hand.\n\n"+
				"My hand: "+getFullScore(cards[0])+"\n"+
				"Your hand: "+getFullScore(cards[1])+"")
				loss = -1
				win = 1
		} else if(getFullScore(cards[1])==getFullScore(cards[0])) {
			if(getFullScore(cards[1])<21 || ((cards[1].size==2) == (cards[0].size==2))) {
				show("Push. No winner this hand.\n\n"+
				"My hand: "+getFullScore(cards[0])+"\n"+
				"Your hand: "+getFullScore(cards[1])+"")
				loss = 0
				win = 0
			} else if(cards[1].size==2) {
				roundPoints = roundPoints * 1.5
				totalPoints -= roundPoints
				show("Blackjack versus point.\n\n"+
				"My hand: "+getFullScore(cards[0])+"\n"+
				"Your hand: "+getFullScore(cards[1])+"")
				loss = -1
				win = 1
			} else if(cards[1].size==2) {
				roundPoints = roundPoints * 1.5
				totalPoints += roundPoints
				show("Point but blackjack for me. You lose this hand.\n\n"+
				"My hand: "+getFullScore(cards[0])+"\n"+
				"Your hand: "+getFullScore(cards[1])+"")
				loss = 1
				win = -1
			}
		} else if(getFullScore(cards[1])>getFullScore(cards[0])) {
			if(getFullScore(cards[1])==21 && (cards[1].size==2))
			{
				roundPoints = roundPoints * 2
				totalPoints -= roundPoints
				show("You have Blackjack! You win this hand.\n\n"+
				"My hand: "+getFullScore(cards[0])+"\n"+
				"Your hand: "+getFullScore(cards[1])+"")
					loss = -1
					win = 1
			} else {
				totalPoints -= roundPoints
				show("You win this hand.\n\n"+
				"My hand: "+getFullScore(cards[0])+"\n"+
				"Your hand: "+getFullScore(cards[1])+"")
					loss = -1
					win = 1
			}
		} else {
			if(getFullScore(cards[0])==21 && (cards[0].size==2))
			{
				roundPoints = roundPoints * 2
				totalPoints += roundPoints
				show("I have Blackjack! You lose this hand.\n\n"+
				"My hand: "+getFullScore(cards[0])+"\n"+
				"Your hand: "+getFullScore(cards[1])+"")
				loss = 1
				win = -1
			} else {
				totalPoints += roundPoints
				show("You lose the hand.\n\n"+
				"My hand: "+getFullScore(cards[0])+"\n"+
				"Your hand: "+getFullScore(cards[1])+"")
				loss = 1
				win = -1
			}
		}
	}
	showButton("Continue.")
}

//End of round
def endRound = {
	//Set stat report format according to game mode
	def midroundMessageReport = "My Clothes Remaining: "+opponentLivesCurrent+"\nYour Clothes Remaining: "+playerLivesCurrent+"\nShocks Due: "+totalPoints+""
	if(gameModeDebug) {
		midroundMessageReport = "My Lives Remaining: "+opponentLivesCurrent+"\nYour Lives Remaining: "+playerLivesCurrent+"\nMy Wins: "+totalLosses+"\nYour Wins: "+totalWins+"\nShocks Due: "+totalPoints+""
	}
	else if(!gameModeStrip) {
			opponentLosses = opponentLivesStart - opponentLivesCurrent
			playerLosses = playerLivesStart - playerLivesCurrent
			if(opponentLosses<0) opponentLosses = 0
			if(playerLosses<0) playerLosses = 0
			midroundMessageReport = "My Losses: "+opponentLosses+" of "+opponentLivesStart+"\nYour Losses: "+playerLosses+" of "+playerLivesStart+"\nShocks Due: "+totalPoints+""
	}
	//Set taunt message and whether points were earned or reduced
	def midroundMessageArray
	def midroundMessagePoints
	//Opponent won round
	if(win==-1) {
		midroundMessageArray = ["You're really going to be hurting after this, "+player+"!",
			"I hope you're ready to be electrified, "+player+"!",
			"The house wins.",
			"Beating you is so much fun!",
			"You don't stand a chance, "+player+".",
			"I'm going to enjoy making you suffer.",
			"You're not very good at this game, are you?",
			"This is almost too easy!"]
		midroundMessagePoints = "You earned "+roundPoints+" "+points+"."
	}
	//Player won round
	else if(win==1) {
		midroundMessageArray = ["I can't believe you won that hand!",
			"Enjoy your victory while you can, "+player+".",
			"You'd better not be cheating!",
			"You got lucky that time.",
			"That was pure luck!",
			"Noooo!",
			"Seriously?!",
			"I think there's something wrong with these cards..."]
		midroundMessagePoints = "You reduced your "+points+" by "+roundPoints+"."
	}
	//Round was a draw
	else {
		midroundMessageArray = ["Shall we continue?",
			"Enjoying yourself?",
			"This is so much fun!",
			"The excitement is building!",
			"Isn't this fun, "+player+"?",
			"Intense, huh?",
			"I like it when you put up a struggle.",
			"I love this game!"]
		midroundMessagePoints = "No "+points+" earned."
	}
	//Display game progress and taunt
	show(""+midroundMessageReport+"\n\n\n"+midroundMessagePoints+"\n\n"+midroundMessageArray[getRandom(8)]+"")
	showButton("Continue")
	//Reset round variables
	win = 0
	loss = 0
	roundPoints = 0
	//Increment turn
	turns++
}

//Adjust lives and win/losses for player and opponent
def roundWinner = {
	//Fix errors
	if(totalPoints<=1) totalPoints = 0
	if(opponentLivesCurrent>=opponentLivesStart) opponentLivesCurrent = opponentLivesStart
	if(playerLivesCurrent>=playerLivesStart) playerLivesCurrent = playerLivesStart
	//Opponent won
	if(win==-1 && totalWins!=0) {
		if(gameModeRegen) {
			opponentLivesCurrent = opponentLivesCurrent + 1
		}
	}
	//Opponent lost
	else if(win==1)	{
		opponentLivesCurrent = opponentLivesCurrent - 1
	}
	//Player won
	if(loss==-1 && totalLosses!=0) {
		totalWins = totalWins + 1
		if(gameModeRegen) {
			playerLivesCurrent = playerLivesCurrent + 1
		}
	}
	//Player lost
	else if(loss==1) {
		totalLosses = totalLosses + 1
		playerLivesCurrent = playerLivesCurrent - 1
	}
    if(gameModeStrip) {
        if (loss == 1)
            setPlayerImage()
        else
            setOpponentImage()
    }
    else setImageGame()
}

//Adjust clothing and show dialog for round winner and loser if stripping
def roundClothing = {
	//Opponent won
	if(win==-1 && totalWins!=0) {
		if(gameModeRegen) {
			show("Seems like I get to put some clothes back on...")
			wait(3)
		}
	}
	//Opponent lost
	else if(win==1)	{
		show("Looks like I lost a piece of clothing...")
		wait(3)
	}	
	//Player won
	if(loss==-1 && totalLosses!=0) {
		if(gameModeRegen) {
			show("Put the last piece of clothing you removed back on.")
			showButton("Done, "+respectTitle+".")
		}
	}
	//Player lost
	else if(loss==1) {
		show("Take off your "+playerClothing[playerLivesStart-1-playerLivesCurrent]+".")
		showButton("Done, "+respectTitle+".")

        // Connect electrodes for next time
        if(playerLivesStart-playerLivesCurrent==playerLivesStart-1) {
            show("You're almost naked now, and I think you need to take this game a bit more seriously!"
            + "\n\nLet's move those electrodes to spot that will provide a bit more motivation! Hummm....")
            wait(15)
            def bodyPart = "penis head"
            def choosePart = getRandom(4)
            if (choosePart == 1) {
                	bodyPart = "penis shaft"
      			setImage("shockblackjack/penis shaft.jpg")
			}
            else if (choosePart == 2) {
                	bodyPart = "balls"
      			setImage("shockblackjack/balls.jpg")
			}
            else if (choosePart == 3) {
      			setImage("shockblackjack/ass hole.jpg")
                	bodyPart = "ass hole"
			} else {
      			setImage("shockblackjack/penis head.jpg")
			}

            show("Move the electrodes to your " + bodyPart + "!")
            showButton("*gulp*")
        }
    }
}

//Player wins the game
def playerWonGame = {
	show("Game over! You won!")
	wait(5)
	show("I guess you've earned your reward.\n\nWhy don't you remove your clothes for me?")
	showButton("Done, "+respectTitle+".")
	strip_level = "4b"
	setImageStrip()
	show("Start stroking your "+cockpussy+".")
	wait(5)
	for(def i = 0;i<150+getRandom(50);i++) {
		playBackgroundSound("tom.wav")
		if(i==40)
			strip_level = "4a"
			setImageStrip()
		if(i==80)
			strip_level = "4b"
			setImageStrip()
		if(i==100)
			setImageWon()
		if(i==140)
			show("Be quick now! I'm leaving in a minute... no time for more.")
		wait(0.6-i/500.0)
	}
	setImageWon()
	show("Sorry, I have to go now, "+player+".")
	wait(10)
}

//Game is over
def gameOver = {
	if(playerLivesCurrent<=0) opponentWonGame()
	else if(opponentLivesCurrent<=0) playerWonGame()
}

//Setup clothes/lives for player and opponent
def setupLives = {
	playerLivesCurrent = playerLivesStart
	opponentLivesCurrent = opponentLivesStart
}


//Start of script
show(null)
setImage(null)
opponentSet1()
show(null)

// Unfinished punishment?
if (loadBoolean ("shockblackjack.inpunish") == true) {
	totalPoints = loadInteger("shockblackjack.points")
	totalPoints = totalPoints * 1.10
	totalPoints = totalPoints.toInteger()
	save("shockblackjack.points",totalPoints)
	setImageLost()
	show("Ummmm.....did you think I'd forget about your punishment?")
	showButton("No, I uh...")
	show("No problem, I understand. Last time wasn't convenient.\n\nI'll just add a few shocks, and we'll call it good.")
	showButton("That sounds fair")
	show("Of course, I'll also require you to place the electrode in the most painful location as well.")
	showButton("I deserve that")

	opponentLivesStart = 6
	opponentLivesCurrent = 6
	setImageSpank()
	opponentWonGame()
}

setImageMain()
wait(1)
intro()
setupLives()
while(!quit) {
	if(getBoolean("Do you want to review the rules?","Yes","I know them"))
	{
		rulesDisplay()
		while(getBoolean("Do you need to go back over the rules again?","Yes","I understand them"))
		{
			rulesDisplay()
		}
	}
	if(gameModeStrip) {
        show(null)
		playerLivesCurrent = playerLivesStart
		opponentLivesStart = playerLivesStart
		opponentLivesCurrent = playerLivesStart

        show(null)
        setImageMain()
	}

    setImage("shockblackjack/ass cheeks.jpg")
    show("Now, just in case you bust or fold, put the electrodes on your ass cheeks and turn up power to 100%. "
        +"\n\nVerify that the power unit is connected to the headphone jack and that volume is also set to 100%.")
    showButton("My ass is wired up, "+respectTitle+".")

	setOpponentImage()
	show("Excellent, then let's play some Blackjack!")
	wait(3)
	setImage(null)
	show(null)
	turns = 0
	while(playerLivesCurrent>0 && opponentLivesCurrent>0) {
		waiting = 2 + (2 / (1+turns/4))
		playBlackjackHand()
        show(null)
		roundWinner()
		if(gameModeStrip) roundClothing()
		endRound()
	}
	gameOver()
	show(goodbye1)
	showButton("Goodbye, "+respectTitle+".")
	quit = true
}
setImage(null)
show(null)
def quitGame = true
if(quitGame) {
	if(loadBoolean("setting.newsetup")) {
		if(loadBoolean("setting.reload")) {
			return "system/welcome"
		}
		else {
			return "system/exit"
		}
	}
	else {
		return null
	}
}

/*
 * Resources
 * scripts/shockblackjack.groovy
 * images/shockblackjack/*
 * images/cards/deck0/*
 * sounds/shockblackjack/*
*/

//END OF SCRIPT
